﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Runtime.Serialization;
using System.Text;
using System.Threading.Tasks;

namespace FiguurLibrary
{
    [DataContract]
    [KnownType(typeof(Vierkant))]
    [KnownType(typeof(Cirkel))]
    public abstract class Figuur
    {
        [DataMember]
        public String Naam { get; set; }

        public abstract double Omtrek { get; }
    }

    [DataContract]
    public class Vierkant : Figuur
    {
        [DataMember]
        public int zijde { get; set; }
        public override double Omtrek
        {
            get { return zijde * 4; }
        }
    }

    [DataContract]
    public class Cirkel : Figuur
    {
        [DataMember]
        public int Straal { get; set; }
        public override double Omtrek
        {
            get { return 2 * Math.PI * Straal; }
        }
    }


}
